unit LDrawFNT;
interface

   { LDrawFNT - vector fonts support.
     Copyright (c) 1993 by Sasha Peslyak }

   Type
      FontType=              array [0..255,0..7] of byte;
      PFontPTRType=          ^PFontType;
      PFontType=
      record
         fp                  :^FontType;
         c1,c2               :char;
         draw                :boolean;
         next                :PFontPTRType;
      end;

      DrawProcType=          procedure (x1,y1,x2,y2,c      :integer);

   Const
      LDrawAspX         :byte=    1;
      LDrawAspY         :byte=    1;
      LDrawAngle        :integer= 0;
      LDrawAngleSin     :integer= 0;
      LDrawAngleCos     :integer= MaxInt;

      PFontPTR     :PFontPTRType = NIL;
     { ⥫  . 樠  祭 㫥 
       ⮬.  祭 ᪮쪨 ⮢ ॠ ४ᨢ
       室 ⮢   , 饣 ᨬ   .
       ਮ ⤠ , 祭  }

   function  GetDrawFPTR(p             :PFontPTRType;
                         c             :char        ) :PFontPTRType;

   function  GetMatrFPTR(p             :PFontPTRType;
                         c             :char        ) :PFontPTRType;

   procedure LDrawProc(var s                     :string;
                       x,y,color                 :integer;
                       mx,dx,my,dy               :word;
                       Line,Rectangle,Bar        :DrawProcType);

   procedure LDraw8x8 (var cd;
                       x,y,color                 :integer;
                       mx,dx,my,dy               :word;
                       Line,Rectangle,Bar        :DrawProcType);

   function  QSin(x                    :integer) :integer;

   function  QCos(x                    :integer) :integer;

   procedure SetLDrawAngle(a           :integer);

   procedure EvalXY(x,y                :integer;
                    var xa,ya          :integer);

implementation

   function GetDrawFPTR;
   begin
      if (p=NIL) or ((c>=p^.c1) and (c<=p^.c2) and p^.draw)
         then GetDrawFPTR:=p else GetDrawFPTR:=GetDrawFPTR(p^.next,c);
   end;

   function GetMatrFPTR;
   begin
      if (p=NIL) or ((c>=p^.c1) and (c<=p^.c2))
         then GetMatrFPTR:=p else GetMatrFPTR:=GetMatrFPTR(p^.next,c);
   end;

   function QSin;
   const
      SinArray     :array [0..90] of integer=
      (0,      572, 1144, 1715, 2286, 2856, 3425, 3993, 4560, 5126, 5690,
        6252, 6813, 7371, 7927, 8481, 9032, 9580,10126,10668,11207,
       11743,12275,12803,13328,13848,14364,14876,15383,15886,16384,
       16876,17364,17846,18323,18794,19260,19720,20173,20621,21062,
       21497,21925,22347,22762,23170,23571,23964,24351,24730,25101,
       25465,25821,26169,26509,26841,27165,27481,27788,28087,28377,
       28659,28932,29196,29451,29697,29934,30162,30381,30591,30791,
       30982,31163,31335,31498,31650,31794,31927,32051,32165,32269,
       32364,32448,32523,32587,32642,32687,32722,32747,32762,32767);

   var
      xn,r         :integer;
   begin
      xn:=abs(x);
      if xn>360 then xn:=xn mod 360;
      case xn of
         0..90:    r:= SinArray[xn];
         91..180:  r:= SinArray[180-xn];
         181..270: r:=-SinArray[xn-180];
         271..360: r:=-SinArray[360-xn];
      end;
      if x>=0 then QSin:=r else QSin:=-r;
   end;

   function QCos;
   begin
      QCos:=QSin(x+90);
   end;

   procedure SetLDrawAngle;
   begin
      LDrawAngle:=a; LDrawAngleSin:=QSin(a); LDrawAngleCos:=QCos(a);
   end;

   procedure EvalXY;
   begin
      xa:= integer(x*longint(LDrawAngleCos) div MaxInt) +
           integer(y*longint(LDrawAngleSin) div MaxInt) *LDrawAspX div LDrawAspY;
      ya:=-integer(x*longint(LDrawAngleSin) div MaxInt) *LDrawAspY div LDrawAspX+
           integer(y*longint(LDrawAngleCos) div MaxInt);
   end;

   procedure LDrawProc;
   var
      t,m,k,i,n,pc,pcl,xc,yc,xl,yl,
      x1,y1,x2,y2,x3,y3,x4,y4                    :integer;
      c,lc                                       :char;

      procedure SVal(b, e    :Integer);
      const
         t         :array [0..3,'0'..'9'] of integer=
         ((0   ,1   ,2   ,3   ,4   ,5   ,6   ,7   ,8   ,9   ),
          (0   ,10  ,20  ,30  ,40  ,50  ,60  ,70  ,80  ,90  ),
          (0   ,100 ,200 ,300 ,400 ,500 ,600 ,700 ,800 ,900 ),
          (0   ,1000,2000,3000,4000,5000,6000,7000,8000,9000));
      var
         i,ti      :byte;
         c         :char;

      begin
         if b>e then Exit;

         m:=0; ti:=0;
         for i:=e downto b do
         begin
            c:=s[i];
            if (c<'0') or (c>'9') then Exit;

            inc(m,t[ti,c]); inc(ti);
            if ti>3 then Exit;
         end;
      end;

   begin
      n:=byte(s[0]); pc:=0; c:=';';
      while pc<n do
      begin
         k:=succ(pc); pcl:=pc;
         while (s[k]<>',') and (k<n) do inc(k);
         lc:=c; pc:=succ(k);
         c:=' ';
         while (c<>';') and (c<>'-') and (c<>'+') and (c<>'*')
            and (c<>'c') and (pc<n) do
         begin
            inc(pc); c:=s[pc];
         end;
         if pc=n then inc(pc);

         SVal(succ(pcl),pred(k));
         if mx=dx then xc:=m else xc:=longint(m)*mx div dx;
         SVal(succ(k),pred(pc));
         if my=dy then yc:=m else yc:=longint(m)*my div dy;
         if LDrawAngle<>0 then
         begin
            x3:=xc; y3:=yc;
            EvalXY(xc,yc,xc,yc);
         end;
         inc(xc,x); inc(yc,y);

         case lc of
            '-': Line      (xl,yl,xc,yc,color);
            '+':
            if LDrawAngle=0 then Rectangle (xl,yl,xc,yc,color) else
            begin
               EvalXY(x3,y1,x2,y2); inc(x2,x); inc(y2,y);
               EvalXY(x1,y3,x4,y4); inc(x4,x); inc(y4,y);
               Line(xl,yl,x2,y2,color);
               Line(x2,y2,xc,yc,color);
               Line(xc,yc,x4,y4,color);
               Line(x4,y4,xl,yl,color);
            end;
            '*': Bar       (xl,yl,xc,yc,color);
         end;
         xl:=xc; yl:=yc; x1:=x3; y1:=y3;
      end;
   end;

   procedure LDraw8x8;
   var
      n                                :byte absolute cd;
      d                                :array [0..255] of byte absolute cd;
      pc,c,lc                          :byte;
      xc,yc,xl,yl,
      x1,y1,x2,y2,x3,y3,x4,y4          :integer;

   begin
      pc:=0; c:=0;
      while pc<n do
      begin
         inc(pc);
         lc:=c;
         c:=d[pc] and 3;

         if mx=dx then xc:=(d[pc] and $E0) shr 5
                  else xc:=longint((d[pc] and $E0) shr 5)*mx div dx;
         if my=dy then yc:=(d[pc] and $1C) shr 2
                  else yc:=longint((d[pc] and $1C) shr 2)*my div dy;

         if LDrawAngle<>0 then
         begin
            x3:=xc; y3:=yc;
            EvalXY(xc,yc,xc,yc);
         end;
         inc(xc,x); inc(yc,y);

         case lc of
            1: Line      (xl,yl,xc,yc,color);
            2:
            if LDrawAngle=0 then Rectangle (xl,yl,xc,yc,color) else
            begin
               EvalXY(x3,y1,x2,y2); inc(x2,x); inc(y2,y);
               EvalXY(x1,y3,x4,y4); inc(x4,x); inc(y4,y);
               Line(xl,yl,x2,y2,color);
               Line(x2,y2,xc,yc,color);
               Line(xc,yc,x4,y4,color);
               Line(x4,y4,xl,yl,color);
            end;
            3: Bar       (xl,yl,xc,yc,color);
         end;
         xl:=xc; yl:=yc; x1:=x3; y1:=y3;
      end;
   end;

end.
